// Programm zur Demonstration der rekursiven Funktionen
// anhand eines Binrbaums
#include <iostream>
using namespace std;
#include <stdlib.h>

// Ein Baumelement besteht aus den Daten und zwei Zeigern
struct Baum
{
    int inhalt;
    Baum * links;
    Baum * rechts;
};

// Zeigt den Baum an, indem es sich selbst ber den linken Zweig
// aufruft, bis das Ende erreicht wurde. Dann zeigt die zuletzt
// aufgerufene Funktion "ihr" Element und ruft sich selbst ber
// den rechten Zeiger auf.
void zeigeBaum(Baum *blatt)
{
    if (blatt==0) return;    // Rekursionsende
    zeigeBaum(blatt->links); // Rekursionsaufruf
    cout << blatt->inhalt << endl; // Anzeige
    zeigeBaum(blatt->rechts); // Rekursionsaufruf
}

// Sucht rekursiv die Stelle, um den inhalt einzusortieren
Baum * fuegeEin(Baum *blatt, int inhalt)
{
    if (blatt==0) // Rekursionsende
    {
        // Position gefunden: Knoten erzeugen und initialisieren
        blatt = new Baum;
        blatt->links = blatt->rechts = 0;
        blatt->inhalt = inhalt;
        return blatt;
    }
    // Suche rekursiv die richtige Position
    if (inhalt < blatt->inhalt)
    {
        blatt->links = fuegeEin(blatt->links, inhalt);
    }
    else if (inhalt > blatt->inhalt)
    {
        blatt->rechts = fuegeEin(blatt->rechts, inhalt);
    }
    return blatt;
}

// Rekursives suche im Baum
Baum * suche(Baum *blatt, int inhalt)
{
    if (blatt==0) return 0; // Rekursionsende
    if (inhalt < blatt->inhalt)
    {
        return suche(blatt->links, inhalt); // Rekursionsaufruf
    }
    else if (inhalt > blatt->inhalt)
    {
        return suche(blatt->rechts, inhalt); // Rekursionsaufruf
    }
    return blatt;
}

int main(int argc, char **argv)
{
    long neuWert;
    int anzahl = 20; // Anzahl der Elemente im Baum
    int start = 9;   // Startwert fr die Zufallsfunktion
    // Ermgliche dem Benutzer, die Vorgaben zu verndern
    if (argc>1)
    {
        anzahl = atoi(argv[1]);
    }
    if (argc>2)
    {
        start = atoi(argv[2]);
    }
    Baum * wurzel = 0; // Die Basis des Baums
    // Flle den Baum mit zuflligen Werten
    srand(start);
    for (int i=0; i<anzahl; i++)
    {
        neuWert = rand() % 100;
        cout << neuWert << " ";
        wurzel = fuegeEin(wurzel, neuWert);
    }
    cout << endl;
    // Zeige das Ergebnis
    zeigeBaum(wurzel);
    // Demonstriere das suche
    if (Baum* erg = suche(wurzel, 12)) 
    {
        cout << "gefunden: " << erg->inhalt << endl;
    }
    else
    {
        cout << "12 nicht gefunden" << endl;
    }
}

