#include <iostream>
#include <string>
using namespace std;

class Bruch
{
public:
    Bruch() {zaehler=0; nenner=1;}
    Bruch(char *);
    explicit Bruch(long);
    void operator()(long) { cout << "Aufrufoperator"; }
    long getNenner() const  {return nenner;}
    long getZaehler() const  {return zaehler;}
    void setNenner(long p) {nenner=p;}
    void setZaehler(long p)  {zaehler=p;}
    void addiere(long);
    void addiere(Bruch);
    Bruch operator+(long);
    Bruch operator+(Bruch);
    operator double() {return double(zaehler)/double(nenner);}
    Bruch& operator++();
    Bruch operator++(int);
    friend ostream& operator<<(ostream&, const Bruch&);
    friend istream& operator>>(istream&, Bruch&);
    friend Bruch operator+(long o1, const Bruch& o2);
    bool operator==(Bruch);
    void kuerze();
private:
    char * liesZiffern(char *inputzeiger);
    long zaehler;
    long nenner;
};


Bruch::Bruch(long para)
{
    zaehler = para;
    nenner = 1;
}


char * Bruch::liesZiffern(char *inputzeiger)
{
    while (*inputzeiger>='0' && *inputzeiger<='9') {
        zaehler *= 10;
        zaehler += (*inputzeiger - '0');
        nenner *= 10;
        inputzeiger++;
    }
    return inputzeiger;
}


Bruch::Bruch(char *eingabe)
{
    char * inputzeiger;

    zaehler=0; nenner=1;
    inputzeiger = eingabe;

    inputzeiger = this->liesZiffern(inputzeiger);
    nenner=1; // da liesZiffern den Nenner *= 10 nimmt. Hier unerwnscht!

    // Ganzzahliger Anteil des Zaehlers ist fertig!

    if (*inputzeiger =='.' || *inputzeiger==',') {
        inputzeiger++;
        inputzeiger = this->liesZiffern(inputzeiger);
        // Nachkommastellen des Zaehlers auch bearbeitet

    } // if

    if (*inputzeiger =='/') {
        Bruch nBr;

        inputzeiger++;
        inputzeiger = nBr.liesZiffern(inputzeiger);
        nBr.nenner = 1; /* siehe oben */

        // Ganzzahliger Anteil des Nenners fertig

        // Folgende Fkt., falls der Nenner auch eine Nachkommastelle hat

        if (*inputzeiger =='.' || *inputzeiger==',') {
            inputzeiger++;
            inputzeiger = nBr.liesZiffern(inputzeiger);

        }

        zaehler *= nBr.nenner;
        nenner  *= nBr.zaehler;
    } // if
    // Jetzt noch Krzen
    kuerze();
}

int ggT(int a, int b)
{
    if (b==0)
    {
        return a;
    }
    else
    {
        return ggT(b, a % b);
    }
}


ostream& operator<<(ostream& stream, const Bruch& bruch)
{
    // return stream << bruch.getZaehler() << '/' << bruch.getNenner();
    return stream << bruch.zaehler << '/' << bruch.nenner;
}

istream& operator>>(istream& stream, Bruch& bruch)
{

    stream >> bruch.zaehler;
    stream >> bruch.nenner;
    return stream;
}

void Bruch::addiere(long summand)
{
    zaehler+=summand*nenner;
}

void Bruch::addiere(Bruch summand)
{
    zaehler = zaehler*summand.getNenner() + summand.getZaehler()*nenner;
    nenner  = nenner * summand.getNenner();
}

Bruch Bruch::operator+(long summand)
{
    zaehler+=summand*nenner;
    return *this;
}

Bruch Bruch::operator+(Bruch summand)
{
    zaehler = zaehler*summand.getNenner() + summand.getZaehler()*nenner;
    nenner  = nenner * summand.getNenner();
    return *this;
}

Bruch operator+(long o1, const Bruch& o2)
{
    Bruch summe;
    cout << "glob. Operatorfkt" << endl;
    // waere die Funktion kein friend von Bruch, muessten
    // die folgenden zwei Zeilen statt der darauffolgenden
    // zwei verwendet werden.
    //    summe.setZaehler(o2.getZaehler()*o2.getNenner());
    //    summe.setNenner(o2.getNenner());
    summe.zaehler = o2.zaehler+o1*o2.nenner;
    summe.nenner = o2.nenner;
    return summe;
}

void Bruch::kuerze()
{
int div; // Divisor

   div = ggT(zaehler,nenner);
   this-> zaehler /= div;
   this->nenner /= div;
}

Bruch& Bruch::operator++()
// Praefix-Inkrement
{
    // berechne den neuen Bruch
    // geht auch: *this = *this + 1;
    zaehler += nenner;
    return *this;
}

Bruch Bruch::operator++(int)
// Postfix-Inkrement
{
    Bruch oldBruch =*this; // alten Stand sichern
    zaehler += nenner;      // Variable erhhen
    return oldBruch;        // return alten Stand
}

bool Bruch::operator==(Bruch vgl)
{
    kuerze();
    vgl.kuerze();
    return (zaehler==vgl.zaehler && nenner==vgl.nenner);
}

int main()
{
    cout << "Zhler/Nenner eingeben!" << endl;
    char bruchString[256];
    cin.getline(bruchString, sizeof(bruchString));
    Bruch s1(bruchString);
    cout << "bruchString" << bruchString << endl;
    cout << "Bruch" << s1 << endl;
    
    cout << "Zhler/Nenner eingeben!" << endl;
    cin.getline(bruchString, sizeof(bruchString));
    Bruch s2(bruchString);
    cout << "s1: " << s1 << "s2: " << s2 << endl;
    double d;
    d = s2;
    cout << "Test d = s2 - double: " << d << endl;
    Bruch s3(12L); // expliziter Konstruktoraufruf
    s3 = long(2) + s1;
    cout << "Test s3 = 2 + s1 - Summe:" << s3 << endl;
    Bruch s4;
    s3 = s1;
    cout << "s3 = s1 - ";
    s4 = ++s3;
    cout << "Test s4 = ++s3 - Ergebnis s4, s3:" 
        << s4 << ',' << s3 << endl;
    s3 = s1;
    cout << "s3 = s1 - ";
    s4 = s3++;
    cout << "Test s4 = s3++ - Ergebnis s4, s3:" 
        << s4 << ',' << s3 << endl;
    if (s1==s2)
        cout << "gleich";
    else
        cout << "ungleich";
    cout << endl;
    s3(12L); // Aufruf des Funktionsoperators
}

