#include <iostream>
using namespace std;

enum Token {
    PLUS, MINUS, MUL, DIV, LPAR, RPAR, NUMBER, END, ERROR};

// Globale Variablen:
Token akToken;     // das zuletzt erkannte Token
double tokenZahlenWert; // der Wert bei Zahlenkonstanten

char *srcPos; // Programm-Position

Token sucheToken()
// Sucht ab der aktuellen Stringposition das nchste Token.
// Hier werden auch die Zahlenkonstanten bestimmt und in
// der globalen Variablen tokenZahlenWert abgelegt.
{
    akToken = ERROR;
    if (*srcPos==0) {
        akToken = END;
    } else {
        switch (*srcPos) {
        case '(': akToken=LPAR;  break;
        case ')': akToken=RPAR;  break;
        case '*': akToken=MUL;   break;
        case '/': akToken=DIV;   break;
        case '+': akToken=PLUS;  break;
        case '-': akToken=MINUS; break;
        }
        if (*srcPos>='0' && *srcPos<'9') {
            akToken=NUMBER;
            tokenZahlenWert = 0.0;
        }
        while (*srcPos>='0' && *srcPos<'9') {
            tokenZahlenWert *= 10;
            tokenZahlenWert += *srcPos-'0';
            srcPos++;
        }
        if (akToken != NUMBER) srcPos++;
    }
    return akToken;
}

Token zeigeFehler(const char *s)
// Meldung ausgeben und Fehler-Token zurckliefern
{
    cerr << s << endl;
    return ERROR;
}

double suchePlusMinus();

double sucheKlammern()
// wertet sucheKlammern, Zahlen und Vorzeichen aus
// ruft sucheKlammern() und suchePlusMinus() dadurch rekursiv!
{
    double wert;
    switch(akToken) {
    case NUMBER:
        sucheToken();
        return tokenZahlenWert;
    case MINUS:
        sucheToken();
        return -sucheKlammern();
    case LPAR:
        sucheToken();
        wert = suchePlusMinus();
        if (akToken != RPAR)
           return zeigeFehler(") expected");
        sucheToken();
        return wert;
    case END:
        return 1;
    default:
        return zeigeFehler("primary expected");
    }
}

double sucheMulDiv()
// wertet Multiplikation und Division aus
// ruft sucheKlammern(), dadurch rekursiv!
{
    double wert;
    // rufe erst die Operation mit der nchsthheren Prioritt
    wert = sucheKlammern();
    while (akToken==MUL || akToken==DIV) {
        if (akToken==MUL) {
            sucheToken();
            wert *= sucheKlammern();
        } else if (akToken==DIV) {
            sucheToken();
            wert /= sucheKlammern();
        }
    }
    return wert;
}

double suchePlusMinus()
// wertet Summe und Differenz aus
// ruft sucheMulDiv(), dadurch rekursiv
{
    double wert;
    // rufe erst die Operation mit der nchsthheren Prioritt
    wert = sucheMulDiv();
    while (akToken==PLUS || akToken==MINUS) {
        if (akToken==PLUS) {
            sucheToken();
            wert += sucheMulDiv();
        } else if (akToken==MINUS) {
            sucheToken();
            wert -= sucheMulDiv();
        }
    }
    return wert;
}

double werteAus(char *s)
{
    srcPos = s;
    sucheToken();   // bestimme schon einmal das erste Token vorweg
    return suchePlusMinus();
}

int main(int argc, char* argv[])
{
    if (argc!=2) {
        cout << "Aufruf mit mathematischem Ausdruck in Anfhrungszeichen!" << endl;
        cout << "Z.B.:" << endl;
        cout << "calc \"8*(12+3)-7\"" << endl;
    } else {
        double wert = werteAus(argv[1]);
        cout << wert << endl;
    }
    return 0;
}

