#include <iostream>
#include <exception>
#include <string>
#include <sstream>
using namespace std;

// Meine eigene Basisklasse, abgeleitet von exception
class MeaCulpa : public exception
{
public:
    MeaCulpa(string s) {this->s = s;}
    virtual ~MeaCulpa() throw() {}
    virtual const char * what() const throw()
        {return s.c_str();}
private:
    string s;
};

// Besonderer Fehler, wenn keine Daten mehr vorliegen
class KeineDatenMehr : public MeaCulpa
{
public:
    KeineDatenMehr(int a) : MeaCulpa(" ") {nr = a;}
    virtual ~KeineDatenMehr() throw() {}
    virtual const char * what() const throw();
private:
    int nr;
    string s;
};

// what() wird für eigene Fehlermeldung überschrieben.
const char * KeineDatenMehr::what() const throw()
{
  ostringstream getNr;
  getNr << "Keine Daten mehr. Fehlernr.: " << nr;
  return getNr.str().c_str();
}

// Eine weitere Fehlerart wird von MeaCulpa abgeleitet.
class QuelleFehlt : public MeaCulpa
{
public:
    QuelleFehlt() : MeaCulpa("Quelle fehlt") {}
};

// tuWas simuliert die beiden Fehlerarten in Abhängigkeit vom
// Parameter.
void tuWas(int problem) throw (KeineDatenMehr, QuelleFehlt)
{
    if (problem==0)
    {
        throw KeineDatenMehr(8);
    }
    if (problem==1)
    {
        throw QuelleFehlt();
    }
}

int main()
{
    // Problem-Nummer eingeben
    int Auswahl;
    cout << "Zahl zwischen 0 und 3 eingeben:" << endl;
    cin >> Auswahl;
    // Der try-Block fängt die Exception in tuWas.
    try
    {
        tuWas(Auswahl);
    }
    // Fängt nur die eigenen Fehler
    catch(MeaCulpa& fehler)
    {
        cout << fehler.what() << endl;
    }
}

