#include <iostream>
using namespace std;

class tSafeString // String-Klasse mit abgesichertem Index
{
public:
    tSafeString(int len) // Max. Länge muss vorgegeben werden.
    {
        maxLen = len;
        safestr = new char[len]; // Externer Speicherwunsch
        mist = 0; // Dummy
    }
    ~tSafeString()
    {
        delete[] safestr;
        safestr=0;
    }
    char& operator[](int i);
    // In einer realen Klasse müsste ein Kopierkonstruktor
    // und ein Zuweisungsoperator implementiert werden.
private:
    char *safestr; // Der String ist extern!
    char mist;     // Dummy für Fehlzugriffe
    int maxLen;
};

char& tSafeString::operator[](int i)
{
    if (i<maxLen && i>=0)
    {
        return *(safestr+i); // Buchstabe gefunden!
    }
    return mist; // return 0 wegen Referenz nicht möglich!
}

int main()
{
    tSafeString str(6); // 6 Zeichen, von 0 bis 5
    str[5] = 'A';       // Schreiben
    char c = str[5];    // Lesen
    cout << c << endl;  // Test, ob es wirklich ein 'A' ist
}

