// Programm zur Demonstration einer Stack-Klasse
#include <iostream>
using namespace std;

class Node     // Knoten einer verketteten Liste
{
public:
    int d;       // Daten, hier ganze Zahlen
    Node *next; // Verkettung
};

// Der Stack als Verbindung aus anker und Operationen
class Stack
{
public:
    Stack();
    ~Stack();
    void push(int);  // fügt Informationen hinzu
    int pop();      // holt Informationen heraus
private:
    Node * anker;  // Jeder Stack hat seinen eigenen Anker.
};

Stack::Stack()
{
    anker = 0;      // Leere Liste wird vorbereitet.
}

// Der Destruktor löscht alle übriggebliebenen Elemente.
Stack::~Stack()
{
   Node *last = anker;  // Hilfszeiger zum Sichern des Ankers
   while (anker)         // solange noch Elemente in der Liste
   {
      last = anker;        // erstes Element sichern
      anker = anker->next; // Anker auf zweites Element setzen
      delete last;         // erstes Element freigeben
   }
}

// Neues Element vorn in die Liste einhängen
void Stack::push(int d)
{
    Node *node = new Node; // erzeugt Listenelement
    node->d = d;             // Besetze das Datenfeld.
    node->next = anker;      // Hänge bisherige Liste an.
    anker = node;            // Mache dieses Element zum Anker.
}

// Oberstes Element auslesen und aus der Liste löschen
int Stack::pop()
{
    int inhalt=0; // Hilfsvariable vom Typ der Elementdaten
    if (anker)    // sofern die Liste nicht schon leer ist
    {
       Node *old = anker;  // Sichere erstes Element.
       anker = anker->next; // Setze Anker auf zweites Element.
       inhalt = old->d;     // Kopiere den Knoteninhalt.
       delete old;          // Ausgelesenen Knoten freigeben
    }
    return inhalt;           // Liefere den Knoteninhalt.
}

int main()    // Hauptprogramm zum Testen des Stacks
{
    Stack stack;   // Lege einen Stack an.
    stack.push(2);  // Schiebe Testdaten darauf.
    stack.push(5);
    stack.push(18);
    cout << stack.pop() << endl; // Lese den Stack aus.
    cout << stack.pop() << endl;
    cout << stack.pop() << endl;
}

