#include <iostream>
using namespace std;

template<class T, int max> class Stack
{
public:
    Stack() : MAXSTACK(max)  // wird bei Definition festgelegt
        { s = new T[MAXSTACK]; index=0;}
    ~Stack() {delete[] s;}
    bool pop(T *); // abholen
    bool push(T ); // drauflegen
private:
    const int MAXSTACK; // Konstante für die Stackgröße
    T *s;               // Der Stack selbst
    int index;          // Aktuelle Position im Stack-Array
};

// Element vom Stack nehmen und freigeben
template<class T, int max> bool Stack<T,max>::pop(T *get)
{
    if (index==0 ) return false; // Ist Stack leer?
    *get = s[--index]; // Element entnehmen
    return true;
}

// Neues Element auf den Stack schieben
template<class T, int max> bool Stack<T,max>::push(T set)
{
    if (index>=MAXSTACK) return false; // Ist Stack überfüllt?
    s[index++] = set; // Element auflegen
    return true;
}

int main() // Testlauf
{
   Stack<int, 2> intStack; // Stack mit zwei Integerelementen
   int a;

   intStack.push(8); // Auffüllen!
   intStack.push(4);
   intStack.push(2); // Hier wird es eng!
   // Ausgabe des Stacks
   for (int i=0; i<3; i++)
   {
       if (intStack.pop(&a))
       {
           cout << a << endl;
       }
   }
}

